#pragma once

#include "WSQImageLibraryNativeMethods32.h"



// Please read the included file "important_notes_for_NET_developers_on_using_WSQ_image_library.html"
// or the page: 
// http://www.cognaxon.com/index.php?page=wsqlib_NETnotes
// FAQ (Frequently Asked Questions)
// for .NET developers on using WSQ image library




namespace WSQ_Visual_C_NET_2008 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

using namespace System::Runtime::InteropServices; // needed for DllImport
using namespace System::Text; // needed for StringBuilder Class
using namespace System::IO;

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{

            comment_text = String::Empty; //need to initialize comment_text in order to avoid crashing

			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: wsq_demo::WSQImageLibraryNativeMethods32 ^WSQ_library_native_methods;
	private:
		IntPtr bp;
		//static IntPtr bp = IntPtr::Zero;
		System::Drawing::Bitmap^ b;
		array<System::Byte>^ input_data_stream;
		array<System::Byte>^ input_data_stream2;
		array<System::Byte>^ output_data_stream;
		array<System::Byte>^ output_data_stream2;
		Int32 width;
		Int32 height;
		Int32 ppi;
		double bitrate;
		System::String^ comment_text;
	private: System::Windows::Forms::PictureBox^  OutputPicture;



	private: System::Windows::Forms::Button^  buttonOpen;
	private: System::Windows::Forms::Button^  buttonSave;
	protected: 


	private: System::Windows::Forms::Button^  buttonWsqToStream;

	private: System::Windows::Forms::Button^  buttonRegister;



	private: System::Windows::Forms::Button^  buttonStreamToWsq;


	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->OutputPicture = (gcnew System::Windows::Forms::PictureBox());
			this->buttonOpen = (gcnew System::Windows::Forms::Button());
			this->buttonSave = (gcnew System::Windows::Forms::Button());
			this->buttonWsqToStream = (gcnew System::Windows::Forms::Button());
			this->buttonRegister = (gcnew System::Windows::Forms::Button());
			this->buttonStreamToWsq = (gcnew System::Windows::Forms::Button());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->OutputPicture))->BeginInit();
			this->SuspendLayout();
			// 
			// OutputPicture
			// 
			this->OutputPicture->Location = System::Drawing::Point(7, 9);
			this->OutputPicture->Name = L"OutputPicture";
			this->OutputPicture->Size = System::Drawing::Size(366, 300);
			this->OutputPicture->TabIndex = 0;
			this->OutputPicture->TabStop = false;
			// 
			// buttonOpen
			// 
			this->buttonOpen->Location = System::Drawing::Point(13, 354);
			this->buttonOpen->Name = L"buttonOpen";
			this->buttonOpen->Size = System::Drawing::Size(75, 23);
			this->buttonOpen->TabIndex = 0;
			this->buttonOpen->Text = L"&Open";
			this->buttonOpen->UseVisualStyleBackColor = true;
			this->buttonOpen->Click += gcnew System::EventHandler(this, &Form1::buttonOpen_Click);
			// 
			// buttonSave
			// 
			this->buttonSave->Enabled = false;
			this->buttonSave->Location = System::Drawing::Point(135, 354);
			this->buttonSave->Name = L"buttonSave";
			this->buttonSave->Size = System::Drawing::Size(75, 23);
			this->buttonSave->TabIndex = 1;
			this->buttonSave->Text = L"&Save";
			this->buttonSave->UseVisualStyleBackColor = true;
			this->buttonSave->Click += gcnew System::EventHandler(this, &Form1::buttonSave_Click);
			// 
			// buttonWsqToStream
			// 
			this->buttonWsqToStream->Location = System::Drawing::Point(13, 316);
			this->buttonWsqToStream->Name = L"buttonWsqToStream";
			this->buttonWsqToStream->Size = System::Drawing::Size(109, 23);
			this->buttonWsqToStream->TabIndex = 2;
			this->buttonWsqToStream->Text = L"WSQ -> Stream";
			this->buttonWsqToStream->UseVisualStyleBackColor = true;
			this->buttonWsqToStream->Click += gcnew System::EventHandler(this, &Form1::buttonWsqToStream_Click);
			// 
			// buttonRegister
			// 
			this->buttonRegister->Location = System::Drawing::Point(269, 316);
			this->buttonRegister->Name = L"buttonRegister";
			this->buttonRegister->Size = System::Drawing::Size(75, 23);
			this->buttonRegister->TabIndex = 4;
			this->buttonRegister->Text = L"&Register";
			this->buttonRegister->UseVisualStyleBackColor = true;
			this->buttonRegister->Click += gcnew System::EventHandler(this, &Form1::buttonRegister_Click);
			// 
			// buttonStreamToWsq
			// 
			this->buttonStreamToWsq->Enabled = false;
			this->buttonStreamToWsq->Location = System::Drawing::Point(135, 316);
			this->buttonStreamToWsq->Name = L"buttonStreamToWsq";
			this->buttonStreamToWsq->Size = System::Drawing::Size(109, 23);
			this->buttonStreamToWsq->TabIndex = 3;
			this->buttonStreamToWsq->Text = L"Stream -> WSQ";
			this->buttonStreamToWsq->UseVisualStyleBackColor = true;
			this->buttonStreamToWsq->Click += gcnew System::EventHandler(this, &Form1::buttonStreamToWsq_Click);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(385, 386);
			this->Controls->Add(this->buttonStreamToWsq);
			this->Controls->Add(this->buttonRegister);
			this->Controls->Add(this->buttonWsqToStream);
			this->Controls->Add(this->buttonSave);
			this->Controls->Add(this->buttonOpen);
			this->Controls->Add(this->OutputPicture);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"WSQ Library Demo";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->OutputPicture))->EndInit();
			this->ResumeLayout(false);

		}
#pragma endregion



		[DllImport("WSQ_library.dll", EntryPoint = "_CreateBMPFromFile", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Ansi)]
		static IntPtr _CreateBMPFromFile(array<System::Byte>^ filename);

		[DllImport("WSQ_library.dll", EntryPoint = "_SaveBMPToFile", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Ansi)]
		static void _SaveBMPToFile(IntPtr hBitmap, array<System::Byte>^ filename, Int32 filetype);

		[DllImport("WSQ_library.dll", EntryPoint = "_RegisterWSQ", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Ansi)]
		static void _RegisterWSQ();

		[DllImport("WSQ_library.dll", EntryPoint = "_SetShowFilePropertiesDialog", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Ansi)]
		static void _SetShowFilePropertiesDialog(Int32 file_properties_dialog);

		[DllImport("WSQ_library.dll", EntryPoint = "_ShowFileConverter", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Ansi)]
		static void _ShowFileConverter();

		[DllImport("WSQ_library.dll", EntryPoint = "_ConvertHBITMAPtoGrayScale256", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Ansi)]
		static IntPtr _ConvertHBITMAPtoGrayScale256(IntPtr hBitmap);

		[DllImport("WSQ_library.dll", EntryPoint = "_SaveHBITMAPtoFileAsGrayScale256BMP", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Ansi)]
		static void _SaveHBITMAPtoFileAsGrayScale256BMP(IntPtr hBitmap, array<System::Byte>^ filename);



private: System::Void buttonRegister_Click(System::Object^  sender, System::EventArgs^  e) {
 			//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
			//_RegisterWSQ();
			WSQ_library_native_methods->pRegisterWSQ();
		 }


private: System::Void buttonOpen_Click(System::Object^  sender, System::EventArgs^  e) {



		OpenFileDialog^ ofd = gcnew OpenFileDialog();

		ofd->Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf \
*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi \
*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp| \
FBI Wavelet Scalar Quantization (*.wsq)|*.wsq| \
Windows bitmaps (*.bmp)|*.bmp| \
Macintosh TIFF images (*.tiff)|*.tiff| \
PC TIFF images (*.tif)|*.tif| \
JPG images (*.jpg)|*.jpg| \
JPEG-2000 Part-1 (*.jp2)|*.jp2| \
JPEG-2000 Code Stream (*.jpc)|*.jpc| \
JPE images (*.jpe)|*.jpe| \
JPEG images (*.jpeg)|*.jpeg| \
Portable network graphic images (*.png)|*.png| \
Compuserve Graphic Interchange Format(*.gif)|*gif| \
Paintshop Pro images (*.psp)|*.psp| \
JFIF images (*.jfif)|*.jfif| \
Run length encoded Windows bitmaps (*.rle)|*.rle| \
Device independant Windows bitmaps (*.dib)|*.dib| \
Truevision images (*.win)|*.win| \
Truevision images (*.vst)|*.vst| \
Truevision images (*.vda)|*.vda| \
Truevision images (*.tga)|*.tga| \
Truevision images (*.icb)|*.icb| \
GFI fax images (*.fax)|*.fax| \
Encapsulated Postscript images (*.eps)|*.eps| \
ZSoft Paintbrush images (*.pcx)|*.pcx| \
ZSoft Paintbrush images (*.pcc)|*.pcc| \
Word 5.x screen capture images (*.scr)|*.scr| \
Alias/Wavefront images (*.rpf)|*.rpf| \
Alias/Wavefront images (*.rla)|*.rla| \
SGI true color images (*.sgi)|*.sgi| \
SGI true color images with alpha (*.rgba)|*.rgba| \
SGI true color images (*.rgb)|*.rgb| \
SGI black/white images (*.bw)|*.bw| \
Photoshop images (*.psd)|*.psd| \
Photoshop images (*.pdd)|*.pdd| \
Portable pixel map images (*.ppm)|*.ppm| \
Portable gray map images (*.pgm)|*.pgm| \
Portable bitmap images (*.pbm)|*.pbm| \
Autodesk images (*.cel)|*.cel| \
Autodesk images (*.pic)|*.pic| \
Kodak Photo-CD images (*.pcd)|*.pcd| \
Dr. Halo images (*.cut)|*.cut| \
Amiga Bitmap Graphic (8 bits)|*.iff| \
Windows icons (*.ico)|*.ico| \
Windows metafiles (*.wmf)|*.wmf| \
Windows enhanced meta files (*.emf)|*.emf";

		ofd->FilterIndex = 1;
		if (ofd->ShowDialog() != System::Windows::Forms::DialogResult::OK)
		{
			return;
		}

		//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods

		UTF8Encoding^ utf8 = gcnew UTF8Encoding;
		bp = _CreateBMPFromFile(utf8->GetBytes(ofd->FileName));
		
		//bp = WSQ_library_native_methods->pCreateBMPFromFile(ofd->FileName);

		b = Image::FromHbitmap(bp);
		OutputPicture->Image = b;

		Int32 h = OutputPicture->Image->Height;
		Int32 w = OutputPicture->Image->Width;
		OutputPicture->SetBounds(0, 0, w, h);

		buttonSave->Enabled = true;

		 }



private: System::Void buttonSave_Click(System::Object^  sender, System::EventArgs^  e) {

			 

		SaveFileDialog^ sfd = gcnew SaveFileDialog();
		sfd->Filter = "WSQ Files (*.wsq)|*.wsq| \
Windows BMP (*.bmp)|*.bmp| \
TIFF Files (*.tif)|*.tif| \
PNG Files (*.png)|*.png| \
JPEG Files (*.jpg)|*.jpg| \
Targa Files (*.tga)|*.tga| \
SGI Files (*.rgb)|*.rgb| \
JPEG-2000 Part-1 (*.jp2)|*.jp2| \
JPEG-2000 Code Stream (*.jpc)|*.jpc| \
PBM - Portable Bitmap Format (*.pbm)|*.pbm| \
PGM - Portable Graymap Format (*.pgm)|*.pgm| \
PPM - Portable Pixmap Format (*.ppm)|*.ppm";

		sfd->FilterIndex = 1;
		if (sfd->ShowDialog() != System::Windows::Forms::DialogResult::OK)
		{
			return;
		}

		//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
		//_SetShowFilePropertiesDialog(1);
		WSQ_library_native_methods->pSetShowFilePropertiesDialog(1);

		Bitmap^ b;
		IntPtr bp;

		b = gcnew Bitmap(OutputPicture->Image);
		bp = b->GetHbitmap();

		//you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
		UTF8Encoding^ utf8 = gcnew UTF8Encoding;
		_SaveBMPToFile(bp, utf8->GetBytes(sfd->FileName), sfd->FilterIndex);

		//WSQ_library_native_methods->pSaveBMPToFile(bp, sfd->FileName, sfd->FilterIndex);


		 }



	private: System::Void buttonStreamToWsq_Click(System::Object^  sender, System::EventArgs^  e) {
				 

	SaveFileDialog^ sfd = gcnew SaveFileDialog();
	sfd->Filter = "WSQ Files (*.wsq)|*.wsq";
	sfd->FilterIndex = 1;
	if (sfd->ShowDialog() != System::Windows::Forms::DialogResult::OK)
	{
		return;
	}


	bitrate = 0.75;
	ppi = 500;
	//comment_text = "";
	comment_text = "Cognaxon";


	input_data_stream2 = gcnew array<System::Byte>(width * height);
	int row, row2, pixel_number, pixel_number2;

	// MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
	for (int y = 0; y < height; y++)
	{
		row = width * y;
		row2 = width * (height - y - 1);
		for (int x = 0; x < width; x++)
		{
			pixel_number = row + x;
			pixel_number2 = row2 + (width - x - 1);

			input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
		}
	}

	int compressedLength;
	WSQ_library_native_methods->pWSQ_encode_stream(input_data_stream2,
		width, height, bitrate, ppi, comment_text,
		output_data_stream2, compressedLength);


	FileStream^ fStream = gcnew FileStream(sfd->FileName, FileMode::OpenOrCreate);
	BinaryWriter^ bw = gcnew BinaryWriter(fStream);

	bw->Write(output_data_stream2);
	bw->Close();
	fStream->Close();
	MessageBox::Show("Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).");



 }

private: System::Void buttonWsqToStream_Click(System::Object^  sender, System::EventArgs^  e) {



		OpenFileDialog^ ofd = gcnew OpenFileDialog();

		ofd->Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq";

		ofd->FilterIndex = 1;
		if (ofd->ShowDialog() != System::Windows::Forms::DialogResult::OK)
		{
			return;
		}

		FileInfo^ fInfo = gcnew FileInfo(ofd->FileName);
		System::Int64 input_stream_length = fInfo->Length;
		FileStream^ fStream = gcnew FileStream(ofd->FileName, FileMode::Open, FileAccess::Read);
		BinaryReader^ br = gcnew BinaryReader(fStream);

		input_data_stream = br->ReadBytes(safe_cast<int>(input_stream_length));

		WSQ_library_native_methods->pWSQ_decode_stream(input_data_stream, safe_cast<int>(input_stream_length), output_data_stream, width, height, ppi, comment_text);

		//Converts WSQ compressed byte array into HBITMAP for showing on screen
		bp = WSQ_library_native_methods->pCreateBMPFromWSQByteArray(input_data_stream, safe_cast<int>(input_stream_length));
		b = Image::FromHbitmap(bp);
		OutputPicture->Image = b;

		Int32 h = OutputPicture->Image->Height;
		Int32 w = OutputPicture->Image->Width;
		OutputPicture->SetBounds(0, 0, w, h);

		int output_data_stream_length = height * width;

		// Saves WSQ compressed byte array to an image file.
	//	WSQ_library_native_methods->pSaveWSQByteArrayToImageFile(input_data_stream, (int)input_stream_length, "C:\\OutputDirectory\\output.jpg", 5);


		MessageBox::Show("WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.");

		br->Close();
		fStream->Close();

		buttonStreamToWsq->Enabled = true;

		 }



};
}

